# stats.tcl
#	system statistics frame 


loadsource stats.common

set ITEM(0) "Samples"
set ITEM(1) "Poll"
set ITEM(2) "Empty events"
set ITEM(3) "Histogram increments"
set ITEM(4) "Transmit buffers"
set ITEM(5) "Transmit data"
set ITEM(6) "Null events"
set ITEM(7) "FIFO empty"
set ITEM(8) ""
set ITEM(9) "FIFO part full"
set ITEM(10) "Bad Data"
set ITEM(11) "Event not accepted"
set ITEM(12) ""
set ITEM(13) "Events"
set ITEM(14) "Transfer Error"
set ITEM(15) "Transfer Wait"
set ITEM(16) ""
set ITEM(17) "No Data"

set ITEM(22) "ML403 events"
set ITEM(23) "ML403 errors"
set ITEM(26) "ML403 flush"
set ITEM(27) "ML403 flushed"


proc click-redisplay {} {
   global RDOUTserver NUM ITEM Stats Rates
   global EGreport

   set-footer "Updating..."
   set EGreport -1
   set-busy

   set StatsBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Stats1' ?value"]
   append StatsBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Stats2' ?value"]

   set RatesBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Rates1' ?value"]
   append RatesBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Rates1' ?value"]

   for {set i 0} {$i < $NUM} {incr i} {
       set Stats($i) [expr [lindex $StatsBlock [expr $i*2]]]
       if {[info exists ITEM($i)]} then {
	   :modify STAT$i :value $Stats($i)
       }
   }

   for {set i 0} {$i < $NUM} {incr i} {
       set Rates($i) [expr [lindex $RatesBlock [expr $i*2]]]
       if {[info exists ITEM($i)]} then {
           :modify RATE$i :value $Rates($i)
       }
   }

   custom_redisplay

   clear-busy
   set EGreport 0
   set-footer "Counts Updated [date]"
}

proc read-Rate {n} {global Rates; return $Rates($n)}
